// BenLincoln.TheLostWorlds.CDGameDotErg
// Copyright 2007-2012 Ben Lincoln
// http://www.thelostworlds.net/
//

// This file is part of BenLincoln.TheLostWorlds.CDGameDotErg.

// BenLincoln.TheLostWorlds.CDGameDotErg is free software: you can redistribute it and/or modify
// it under the terms of version 3 of the GNU General Public License as published by
// the Free Software Foundation.

// BenLincoln.TheLostWorlds.CDGameDotErg is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with BenLincoln.TheLostWorlds.CDGameDotErg (in the file LICENSE.txt).  
// If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.Text;

namespace BenLincoln.TheLostWorlds.CDGameDotErg
{
    public class ERGVariableCollection
    {
        protected ERGVariable[] _Variables;

        #region Properties

        public ERGVariable[] Variables
        {
            get
            {
                return _Variables;
            }
            set
            {
                _Variables = value;
            }
        }

        #endregion

        public ERGVariableCollection(int numVariables)
        {
            _Variables = new ERGVariable[numVariables];
        }

        public int GetIndexFromName(string category, string variableName)
        {
            for (int i = 0; i <= _Variables.GetUpperBound(0); i++)
            {
                if ((_Variables[i].Category.ToLower() == category.ToLower()) 
                    && (_Variables[i].Name.ToLower() == variableName.ToLower()))
                {
                    return i;
                }
            }
            throw new KeyNotFoundException("Variable collection does not contain '" + category 
                + "' \\ '" + variableName + "'.");
        }

        public bool ContainsVariable(string category, string variableName)
        {
            foreach (ERGVariable var in _Variables)
            {
                if ((var.Category.ToLower() == category.ToLower()) && (var.Name.ToLower() == variableName.ToLower()))
                {
                    return true;
                }
            }
            return false;
        }
    }
}
