// BenLincoln.TheLostWorlds.CDGameDotErg
// Copyright 2007-2012 Ben Lincoln
// http://www.thelostworlds.net/
//

// This file is part of BenLincoln.TheLostWorlds.CDGameDotErg.

// BenLincoln.TheLostWorlds.CDGameDotErg is free software: you can redistribute it and/or modify
// it under the terms of version 3 of the GNU General Public License as published by
// the Free Software Foundation.

// BenLincoln.TheLostWorlds.CDGameDotErg is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with BenLincoln.TheLostWorlds.CDGameDotErg (in the file LICENSE.txt).  
// If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.Text;

namespace BenLincoln.TheLostWorlds.CDGameDotErg
{
    public class GameLevel
    {
        protected string _Name;
        protected GameArea[] _Areas;

        #region Properties

        public string Name
        {
            get
            {
                return _Name;
            }
        }

        public GameArea[] Areas
        {
            get
            {
                return _Areas;
            }
            set
            {
                _Areas = value;
            }
        }

        #endregion

        public GameLevel(string name)
        {
            _Name = name;
            _Areas = new GameArea[1];
        }

        public GameArea GetAreaByName(string name)
        {
            foreach (GameArea area in _Areas)
            {
                if (area.Name == name)
                {
                    return area;
                }
            }
            throw new KeyNotFoundException("Level '" + _Name + "' does not contain an area called '" + name + "'.");
        }

        public bool ContainsArea(string name)
        {
            foreach (GameArea area in _Areas)
            {
                if (area.Name == name)
                {
                    return true;
                }
            }
            return false;
        }
    }
}
